freeslot(
	"S_SOPHIAHEAD",
	"MT_SOPHIAHEAD",
	"SPR_SHED",
	"S_SOPHIAMISSILE",
	"MT_SOPHIAMISSILE",
	"sfx_sphfir",
	"sfx_sphhit",
	"sfx_sphkil",
	"sfx_sphjmp",
	"sfx_sphhov",
	"sfx_sphgru"
)

local beamres = CV_RegisterVar({
	name = "sph_beamresolution",
	defaultvalue = "0.25",
	flags = CV_SHOWMODIF|CV_FLOAT,
	PossibleValue = {MIN = 1, MAX = FRACUNIT-1},
	func = nil
})

local headFunc = function(mo,t,p)	
	if not (mo and t and p and mo.valid and t.valid and p.sophia)
		return 
	end
		
	mo.angle = t.angle
	mo.z = $-min(max(t.momz,-FRACUNIT*4),FRACUNIT*4)+FRACUNIT*4
	mo.dispoffset = 3
	if p.sophia.target and p.sophia.target.valid
		local pst = p.sophia.target
		mo.angle = R_PointToAngle2(mo.x,mo.y,pst.x,pst.y)
	end
end

local dealSophiaDamage = function(targ,p)
	for i = 1,FRACUNIT,fixdiv(10*FRACUNIT-beamres.value,R_PointToDist2(p.mo.x,p.mo.y,targ.x,targ.y)) do
		local thok = P_SpawnMobj(ease.linear(i,p.mo.x,targ.x),ease.linear(i,p.mo.y,targ.y),ease.linear(i,p.mo.z+(p.mo.height/2),targ.z+(targ.height/2)),MT_THOK)
		thok.color = p.skincolor
		thok.scale = p.mo.scale / 2
		thok.destscale = thok.scale / 4
	end
	
	if targ.flags2 & MF2_FRET
	or (targ.player and (targ.player.powers[pw_flashing] or targ.player.powers[pw_invulnerability]))
		return end
		
	if targ.type == MT_METALSONIC_BATTLE
	and targ.state == S_METALSONIC_FLOAT
		P_InstaThrust(targ,R_PointToDist2(p.mo.x,p.mo.y,targ.x,targ.y),0)
		--p.sophia.firetime = 2
		--targ.state = S_METALSONIC_STUN
		--targ.flags = ($&~MF_SLIDEME)|MF_GRENADEBOUNCE|MF_ENEMY|MF_SHOOTABLE
	elseif not targ.sophiadamage
		targ.sophiadamage = 1
		S_StartSound(targ,sfx_sphhit)
	elseif (targ.sophiadamage < 2 and (~targ.flags & MF_BOSS or targ.type == MT_METALSONIC_BATTLE))
	or (targ.sophiadamage < 7 and targ.flags & MF_BOSS and targ.type != MT_METALSONIC_BATTLE)
		targ.sophiadamage = $+1
		S_StartSound(targ,sfx_sphhit)
	else
		S_StartSound(targ,sfx_sphkil)
		targ.sophiadamage = 0
		if targ.tracer and targ.tracer.type == MT_EGGSHIELD
			P_KillMobj(targ.tracer,nil,p.mo)
			S_StartSound(targ,sfx_wbreak)
		elseif targ.flags & MF_MONITOR
			P_KillMobj(targ,nil,p.mo)
		else
			P_DamageMobj(targ,nil,p.mo)
			S_StartSound(nil,sfx_itemup,p)
			P_GivePlayerRings(p,1)
		end
		if targ.flags & MF_BOSS
			P_GivePlayerRings(p,1)
		end
	end
end

local sophiaGearShift = function(p)
	local gear = p.sophia.gear
	
	if gear == 0
		p.accelstart = 64
		p.normalspeed = 32*FRACUNIT
		p.actionspd = 28*FRACUNIT
		p.jumpfactor = FRACUNIT*85/100
		p.sophia.range = 600*FRACUNIT
		p.sophia.firerate = 12
		p.sophia.lavaresist = 10
	elseif gear == 1
		p.accelstart = 64
		p.normalspeed = 36*FRACUNIT
		p.actionspd = 34*FRACUNIT
		p.jumpfactor = FRACUNIT
		p.sophia.range = 800*FRACUNIT
		p.sophia.firerate = 10
		p.sophia.lavaresist = 7
	elseif gear == 2
		p.accelstart = 96
		p.normalspeed = 36*FRACUNIT
		p.actionspd = 40*FRACUNIT
		p.jumpfactor = FRACUNIT
		p.sophia.range = 1000*FRACUNIT
		p.sophia.firerate = 8
		p.sophia.lavaresist = 4
	else
		p.accelstart = 128
		p.normalspeed = 40*FRACUNIT
		p.actionspd = 46*FRACUNIT
		p.jumpfactor = FRACUNIT*1355/1000
		p.sophia.range = 1200*FRACUNIT
		p.sophia.firerate = 5
		p.sophia.lavaresist = 1
	end
end

local sophiaShiftDown = function(p)
	S_StartSound(p.mo,sfx_kc65)
end

local sophiaShiftUp = function(p)
	S_StartSound(p.mo,sfx_sphgru)
end

local sophiaCheckGear = function(p)
	local r = p.rings
	local g = p.sophia.gear
	p.sophia.lastcheckedgear = r
	
	if r == 0
	and g != 0
		p.sophia.gear = 0
		sophiaGearShift(p)
		sophiaShiftDown(p)
	elseif g == 0
		if r >= 12
			p.sophia.gear = 1
			sophiaGearShift(p)
			sophiaShiftUp(p)
		end
	elseif g == 1
		if r < 8
			p.sophia.gear = 0
			sophiaGearShift(p)
			sophiaShiftDown(p)
		elseif r >= 24
			p.sophia.gear = 2
			sophiaGearShift(p)
			sophiaShiftUp(p)
		end
	elseif g == 2
		if r < 20
			p.sophia.gear = 1
			sophiaGearShift(p)
			sophiaShiftDown(p)
		elseif r >= 48
			p.sophia.gear = 3
			sophiaGearShift(p)
			sophiaShiftUp(p)
		end
	else
		p.sophia.gear = 3
		if r < 45
			p.sophia.gear = 2
			sophiaGearShift(p)
			sophiaShiftDown(p)
		end
	end
end

----------------------------------------------------------------------------------------------------------------------------------------------------------

addHook("PostThinkFrame",function()
	for p in players.iterate
		if p.mo and p.mo.valid and p.mo.skin == "sophia" and p.followmobj and p.followmobj.valid
			headFunc(p.followmobj,p.mo,p)
		end
	end
end)

addHook("PlayerSpawn",function(p)
	if skins[p.skin].name == "sophia"
		p.sophia = {
			target = nil,
			lastinput = nil,
			lastcheckedgear = -1,
			gear = -1,
			range = 0,
			firerate = TICRATE/3,
			lavaresist = TICRATE/2
		}
	end
end)

addHook("PlayerThink",function(p)
	local mo = p.mo
	
	if not (p.sophia and mo and mo.valid)
		return end
		
	if p.sophia.lastinput == nil
		p.sophia.lastinput = p.cmd.buttons
	end
	
	
	if not (p.powers[pw_strong] & STR_FLOOR)
		p.powers[pw_strong] = $|STR_FLOOR
	end
	
	if p.sophia.gear == -1
		p.sophia.gear = 0
		sophiaGearShift(p)
		p.sophia.lastcheckedgear = p.rings
	elseif p.rings != p.sophia.lastcheckedgear
		sophiaCheckGear(p)
	end
		
	local targ = nil
	local targ2 = nil
	local range = p.sophia.range
	
	searchBlockmap("objects",function(r,f)
		local objectdir = R_PointToAngle2(r.x,r.y,f.x,f.y)
		local rvec = {cos(r.angle),sin(r.angle)}
		local fvec = {2*cos(objectdir),2*sin(objectdir)}
		
		if P_CheckSight(r,f)
		and (f.flags & (MF_ENEMY|MF_SHOOTABLE|MF_MONITOR)
		or f.state == S_METALSONIC_FLOAT)
		and f != r
		and f != r.followmobj
		and R_PointToDist2(r.x,r.y,f.x,f.y) <= range
		and (not (targ and targ.valid)
		or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,targ.x,targ.y))
		and not f.player
		--and fixmul(rvec[1], fvec[1]) + fixmul(rvec[2], fvec[2]) >= 0
			targ = f
		end
	end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	
	if p.sophia.gear == 3
		searchBlockmap("objects",function(r,f)
			local objectdir = R_PointToAngle2(r.x,r.y,f.x,f.y)
			local rvec = {cos(r.angle),sin(r.angle)}
			local fvec = {2*cos(objectdir),2*sin(objectdir)}
			
			if P_CheckSight(r,f)
			and f.flags & (MF_ENEMY|MF_SHOOTABLE|MF_MONITOR)
			and f != r
			and f != r.followmobj
			and f != targ
			and R_PointToDist2(r.x,r.y,f.x,f.y) <= range
			and (not (targ2 and targ2.valid)
			or R_PointToDist2(r.x,r.y,f.x,f.y) < R_PointToDist2(r.x,r.y,targ2.x,targ2.y))
			and not f.player
			--and fixmul(rvec[1], fvec[1]) + fixmul(rvec[2], fvec[2]) >= 0
				targ2 = f
			end
		end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
	end
	
	p.sophia.target = targ
	if targ and targ.valid and targ.health
		local canhittarg2 = (targ2 and targ2.valid and targ2.health)
		
		P_SpawnLockOn(p,targ,S_LOCKON1)
		if canhittarg2
			P_SpawnLockOn(p,targ2,S_LOCKON2)
		end
		
		if p.cmd.buttons & BT_SPIN
		--and not (p.sophia.lastinput & BT_SPIN)
		and not p.sophia.firetime
			S_StartSound(mo,sfx_sphfir)
			p.sophia.firetime = p.sophia.firerate
			dealSophiaDamage(targ,p)
		elseif p.cmd.buttons & BT_CUSTOM1
		and not (p.sophia.lastinput & BT_CUSTOM1)
		and p.sophia.gear
			p.rings = $-2
			P_SpawnXYZMissile(mo, targ, MT_CYBRAKDEMON_MISSILE, mo.x, mo.y, mo.z)
			if canhittarg2
				P_SpawnXYZMissile(mo, targ2, MT_CYBRAKDEMON_MISSILE, mo.x, mo.y, mo.z)
			end
		end
	end
	
	if p.skidtime
	and p.glidetime
		mo.state = S_PLAY_GLIDE_LANDING
		p.skidtime = min($,1)
	end
	
	if mo.state == S_PLAY_GLIDE
	and not S_SoundPlaying(mo,sfx_sphhov)
		S_StartSound(mo,sfx_sphhov)
	elseif mo.state != S_PLAY_GLIDE
	and S_SoundPlaying(mo,sfx_sphhov)
		S_StopSoundByID(mo,sfx_sphhov)
	end
	
	p.sophia.lastinput = p.cmd.buttons
	if p.sophia.firetime
		p.sophia.firetime = $-1
	end
	
	if p.sophia.lavaresisttics
		p.sophia.lavaresisttics = $-1
	end
end)

hud.add(function(v,p,cam)
	if not p.sophia
		return end
		
	local gearstring = p.sophia.gear
	if gearstring == 3
		gearstring = "Max"
	end
	
	v.drawString(310,180,"Gear " .. gearstring,V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_HUDTRANS,"right")
end)

addHook("ShouldDamage",function(t,i,s,d,dt)
	if i == nil
	and s == nil
	and t and t.valid 
	and t.player and t.player.sophia
	and dt == DMG_FIRE
	and not (t.player.powers[pw_flashing] or t.player.powers[pw_invulnerability])
	and ~t.player.powers[pw_shield] & SH_PROTECTFIRE
		if t.player.sophia.lavaresisttics
			return false
		elseif t.player.rings <= 0
			return true
		else
			t.player.sophia.lavaresisttics = t.player.sophia.lavaresist
			t.player.rings = $-1
			return false
		end
	end
end)